﻿Imports System.Threading

Public Class SizeableDraggable


    Private MouseResizeBorderWidth As Integer = 5               'gibt an, ab welchen Abstand zum Rand die Resize-Funktion aktiviert sein soll.
    Private MouseResizePosition As Integer = 0                  'gibt den aktuellen Aufenthaltsort der Maus an, um beim Klick spezifisch zu Agieren.
    Private MouseResizeClicked As Boolean = False               'Currently Clicked ? True / False. 
    Private MouseResizeStartingPos As Point = New Point(0, 0)   'Position des Mauszeigers, beim Starten des Resizen´s.

    Private Sub BorderMouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseMove

        Label1.Text = "PosIndex: " & MouseResizePosition.ToString 'Debugging Textbox
        Label2.Text = "MouseBtn: " & MouseResizeClicked.ToString 'Debugging Textbox

        If MouseResizeClicked = False Then
            If e.Location.X >= Me.Width - MouseResizeBorderWidth And e.Location.Y >= Me.Height - MouseResizeBorderWidth Then
                Cursor.Current = Cursors.PanSE 'unten Rechts
                MouseResizePosition = 1

            ElseIf e.Location.X <= MouseResizeBorderWidth And e.Location.Y <= MouseResizeBorderWidth Then
                Cursor.Current = Cursors.PanNW 'oben links
                MouseResizePosition = 2

            ElseIf e.Location.X >= MouseResizeBorderWidth And e.Location.Y >= Me.Height - MouseResizeBorderWidth Then
                Cursor.Current = Cursors.PanSouth 'links
                MouseResizePosition = 3

            ElseIf e.Location.X >= Me.Width - MouseResizeBorderWidth And e.Location.Y <= MouseResizeBorderWidth Then
                Cursor.Current = Cursors.PanNE 'oben rechts
                MouseResizePosition = 4


            ElseIf e.Location.Y >= Me.Height - MouseResizeBorderWidth Then
                Cursor.Current = Cursors.PanSW 'unten
                MouseResizePosition = 5

            ElseIf e.Location.X >= Me.Width - MouseResizeBorderWidth Then
                Cursor.Current = Cursors.PanEast 'rechts
                MouseResizePosition = 6

            ElseIf e.Location.X <= MouseResizeBorderWidth Then
                Cursor.Current = Cursors.PanWest 'unten links
                MouseResizePosition = 7

            ElseIf e.Location.Y <= MouseResizeBorderWidth Then
                Cursor.Current = Cursors.SizeAll 'oben
                MouseResizePosition = 8

            Else
                Cursor.Current = Cursors.Arrow
                MouseResizePosition = 0
            End If

        Else
            Dim DifferenceMousePos As Point = New Point(0, 0)
            DifferenceMousePos = MouseResizeStartingPos - e.Location

            Select Case MouseResizePosition
                Case 0 'Nothing to do ;-)

                Case 1
                    Cursor.Current = Cursors.PanSE 'unten Rechts
                    Me.Width = Me.Width - DifferenceMousePos.X
                    Me.Height = Me.Height - DifferenceMousePos.Y

                Case 2
                    Cursor.Current = Cursors.PanNW 'oben links
                    Me.Top = Me.Top - DifferenceMousePos.Y
                    Me.Left = Me.Left - DifferenceMousePos.X
                    Me.Width = Me.Width + DifferenceMousePos.X
                    Me.Height = Me.Height + DifferenceMousePos.Y

                Case 3
                    Cursor.Current = Cursors.PanSouth 'unten
                    Me.Height = Me.Height - DifferenceMousePos.Y

                Case 4
                    Cursor.Current = Cursors.PanNE 'oben rechts

                Case 5
                    Cursor.Current = Cursors.PanSE 'unten links


                Case 6
                    Cursor.Current = Cursors.PanEast 'rechts
                    Me.Width = Me.Width - DifferenceMousePos.X

                Case 7
                    Cursor.Current = Cursors.PanWest 'links

                Case 8
                    Cursor.Current = Cursors.SizeAll 'oben


            End Select

            'Thread.Sleep(100)  'Diente zum sauberen Nachvollziehen einer Resize- oder Dragging-Aktion
        End If

        MouseResizeStartingPos = e.Location '



    End Sub

    'Click Setzen True
    Private Sub BorderMouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseDown
        MouseResizeClicked = True
        Label2.Text = MouseResizeClicked.ToString 'Debugging Textbox
    End Sub

    'Click Entfernen False 
    Private Sub BorderMouseRelease(ByVal sender As Object, ByVal e As MouseEventArgs) Handles Me.MouseUp
        MouseResizeClicked = False
        Label2.Text = MouseResizeClicked.ToString 'Debugging Textbox
    End Sub



End Class
